		rebuild: function(index) {
			// Get the new HTML from the DOM
			this.anchors = this.element.getElementsByTagName("a");
 
			this.length = this.anchors.length;
			
			var length = index ? index + 1 : this.thumbs.length;
			index = index || 0;
				
			// If the item at index isn't visible then we don't want to run
			if(index >= this.thumbs.length)
				return;
			
			// Loop through the thumbs and update their values/titles/descriptions
			for(var i = index; i < length; i++) {
				if(!this.anchors[i]) {
					// Remove all the items after i					
					for(var j = i; j < this.thumbs.length; j++)
						this.thumbs[j].parentNode.removeChild(this.thumbs[j]);
					
					// Update the thumbs array
					this.thumbs.splice(i, length-i);
					
					break;
				}
				
				var thumb = this.thumbs[i],
					anchor = thumb.firstElementChild,
					img = anchor.firstElementChild,
					title = anchor.nextSibling,
					height = this.anchors[i].getAttribute("data-height"),
					width = this.anchors[i].getAttribute("data-width");
				
				thumb.className = "bloxx-thumb";
				
				this.thumbWidth = (parseInt(width) + this.margin * 2 + this.spacing);
				
				// Set the height (so we don't have to wait for the resource to load)
				img.style.height = height + "px";
				
				// Set the href, src and width/height attributes
				anchor.href = this.anchors[i].href;
				anchor.setAttribute("data-height", height);
                anchor.setAttribute("data-width", width);
				
				removeEvt(img, "load", this, false);
				img.src = this.anchors[i].getAttribute("data-thumb");
				
                if(this.thumbTitles) {
                    // Update the title
                    var newTitle = this.anchors[i].getAttribute("title");
                    // Add or remove the old title
                    if(title) {
                        if(newTitle)
                            title.textContent = newTitle;
                        else {
                            thumb.removeChild(title);
							anchor.className = "bloxx-anchor";
                        }
                    }
                    else {
                        if(newTitle) {
                            title = thumb.appendChild(document.createElement("h2"));
                            title.textContent = newTitle;
							anchor.className = anchor.className + " thumb-title";
                        }
                    }
                }
                else {
                    if(title) {
                        thumb.removeChild(title);
						anchor.className = "bloxx-anchor";
                    }
                }
			}
			
			// If we're in slide view...
			if(this.STATE == "slide") {
				//this.gridControls.appendChild(this.loader);
				
				// We may have had some images removed, update the index so it's not pointing at nothing
				this.index = this.index < this.length ? this.index : this.length-1;
								
				// Update active, prev and next slide based on the images at the current index.)
				//on(this.currentImage, "load", this, false);
				var _this = this;
				this.currentImage.addEventListener("load", function() { _this.resize() }, false);
				this.currentImage.src = this.anchors[this.index].href;
				
				// Add/update the link on the image at index
				if(this.index == index)
					this.addOrUpdateLink(this.activeSlide, index);
				else if(this.index-1 == index)
					this.addOrUpdateLink(this.prevSlide, index);
				else if(this.index+1 == index)
					this.addOrUpdateLink(this.nextSlide, index);
								
				// Update the previous and next slides
				// If there are more anchors before this.index
				if(this.anchors[this.index-1]) {
					on(this.prevImage, "load", this, false);
					this.prevImage.src = this.anchors[this.index-1].href;
					
					// If the next button is disabled, enable it and create a new slide
					if(/bloxx-disabled/.test(this.prevButton.className)) {						
						this.prevButton.className = "bloxx-prev";
						this.prevButton.title = this.prevImageText;
						on(this.prevButton, "click", this, false);
					}
					
					//this.addOrUpdateLink(this.prevSlide, index-1);
				}
				// Otherwise, nullify the slides/images and disable the next button
				else {
					if(this.prevSlide && this.prevSlide.parentNode)
						this.prevSlide.parentNode.removeChild(this.prevSlide);
					this.prevSlide =
					this.prevImage = null;
					this.prevButton.className += " bloxx-disabled";
					this.prevButton.title = null;
					removeEvt(this.prevButton, "click", this, false);
				}
				
				// If there are more anchors after the index
				if(this.anchors[this.index+1]) {
					// If the next button is disabled, enable it and create a new slide
					if(/bloxx-disabled/.test(this.nextButton.className)) {
						this.nextSlide = this.nextSlide || this.slidesWrapper.appendChild(document.createElement("figure"));
						this.nextSlide.className = "bloxx-slide bloxx-slide-next";
						this.nextSlide.style.left = windowWidth()*(this.slideShift+1) + "px";
						this.nextImage = this.addImage(this.nextSlide, this.thumbs.length);
						
						this.nextButton.className = "bloxx-next";
						this.nextButton.title = this.nextImageText;
						on(this.nextButton, "click", this, false);
					}
					on(this.nextImage, "load", this, false);
					this.nextImage.src = this.anchors[this.index+1].href;
					
					//this.addOrUpdateLink(this.nextSlide, index+1);
				}
				// Otherwise, nullify the slides/images and disable the next button
				else {
					if(this.nextSlide && this.nextSlide.parentNode)
						this.nextSlide.parentNode.removeChild(this.nextSlide);
					this.nextSlide =
					this.nextImage = null;
					this.nextButton.className += " bloxx-disabled";
					this.nextButton.title = null;
					removeEvt(this.nextButton, "click", this, false);
				}
				
				// Update/remove the titles and descriptions for all three slides
                this.addCaptions(this.anchors[this.index], this.currentImage);
                if(this.anchors[this.index-1])
                    this.addCaptions(this.anchors[this.index-1], this.prevImage);
                if(this.anchors[this.index+1])
                    this.addCaptions(this.anchors[this.index+1], this.nextImage);
			}
			
			if(this.STATE == "grid" || this.STATE == "slide") {
				this.resizeGrid(true);
            }
            if(this.STATE == "slide") {
                this.resize(true);
            }

		},
		addOrUpdateLink: function(slide, index) {
			
			var anchor = this.anchors[index],
			
			// Check if there's a link on the image in Exhibeo
				inputLink = anchor.getAttribute("data-url"),
			
			// Check if there's a link in the slide in the output
				outputLink = slide.getElementsByTagName("a");
			
			if(outputLink.length)
				outputLink = outputLink[0];
			else
				outputLink = null;
			
			// If there's an inputLink and an outputLink, just update the output with the input
			if(inputLink && outputLink) {
				outputLink.href = inputLink;
			}
			// otherwise, if there's an inputLink and no outputLink, add it
			else if(inputLink && !outputLink) {
				var imageContainer = slide.getElementsByClassName("bloxx-image")[0],
					image = imageContainer.firstElementChild;
				outputLink = imageContainer.appendChild(document.createElement("a"));
				
				outputLink.href = inputLink;
				outputLink.appendChild(image);
			}
			// otherwise, if there's an outputLink and no inputLink, remove it
			else if(!inputLink && outputLink) {
				outputLink.parentNode.insertBefore(outputLink.firstElementChild, outputLink);
				outputLink.parentNode.removeChild(outputLink);
			}
			
			// If there's an outputLink and it should open in a new window, set target
			if(this.openLinksInNewWindow && outputLink) {
				outputLink.target = "_blank";
			}
			// otherwise, if there's an outputLink, it has a target and it shouldn't open in a new window, remove target
			else if(!this.openLinksInNewWindow && outputLink && outputLink.target) {
				outputLink.target = null;
			}
		},
		setShowThumbs: function(showThumbs) {
			this.showThumbs = showThumbs;
			
			if(!this.showThumbs && this.STATE == "grid")
				this.zoom(0);
			else
				this.resizeGrid(true);
		},
		setThumbTitlesEnabled: function(thumbTitlesEnabled) {
			this.thumbTitles = thumbTitlesEnabled;
			this.rebuild();
		},
		setShowImages: function(showImages) {
			this.showImages = showImages;
			
			if(!this.showImages && this.STATE == "slide") {
				if(!this.showThumbs) {
					this.showThumbs = true;
				}
				this.close();
			}
			
			if(this.STATE == "grid" || this.STATE == "slide") {
				var length = this.anchors.length;
				
				// Loop through the thumbs and update their event/href
				for(var i = 0; i < length; i++) {
					var thumb = this.thumbs[i],
					anchor = thumb.firstElementChild;
					
					if(this.showImages) {
						on(anchor, "click", this, false);
						anchor.href = this.anchors[i].href;
					} else {
						removeEvt(anchor, "click", this, false);
						anchor.href = this.anchors[i].getAttribute("data-url");
					}
				}
			}
		},
		setImageDescriptionsEnabled: function(imageDescriptionsEnabled) {
			this.captions = imageDescriptionsEnabled;
			this.rebuild();
		},
		thumbPropertyChanged: function(index, size) {
			this.thumbWidth = size + (this.margin * 2) + this.spacing;
			this.rebuild(index);
		},
		imagePropertyChanged: function(index) {
			this.rebuild(index);
		},
		updateOpenLinksInNewWindow: function(linksInNewWindow) {
			this.openLinksInNewWindow = linksInNewWindow;
			this.rebuild(this.index);
		},
        updateThumbBorderWidth: function(width) {
            this.thumbWidth -= this.margin * 2 + this.spacing;
            this.thumbWidth += width * 2 + this.spacing;
            this.margin = width;
            var _this = this;
            setTimeout(function() { _this.resizeGrid(true) }, 300);
        },
        updateImageBorderWidth: function(width) {
            this.borderSize = width;
            this.resize(true);
        },